<template>
  <div
    :class="{
      WorkforceLane: true,
      'WorkforceLane--active': active,
    }"
    class="WorkforceLane"
    :style="timelineWidth()"
  >
    <div class="WorkforceLane__Head">
      <PSkeleton v-if="name === false" />
      <span v-else>{{ name }}</span>
    </div>
    <ul
      ref="laneElement"
      class="WorkforceLane__Tasks"
      @dragenter="dragEnter"
      @dragleave="dragLeave"
      @dragover="dragOver"
      @drop="drop"
    >
      <NowBlock />
      <WeekendBlocks />
      <TaskComponent
        v-for="task of taskMap?.values()"
        :key="task.id"
        :task="task"
        class="WorkforceLane__Task"
        :style="dateToPosition(task)"
        resizable
        @move:estimated-end-date="handleMoveMax"
        @end:estimated-end-date="handleEndMax"
      />
      <TaskPreview
        v-if="dropTask"
        :task="dropTask"
        class="WorkforceLane__Task"
        :style="dateToPosition(dropTask)"
      />
    </ul>
  </div>
</template>

<script lang="ts" setup>
import TaskComponent from './Task.vue'
import TaskPreview from './TaskPreview.vue'
import { dateToPosition, timelineWidth } from './timedPosition'
import { useI18n } from 'vue-i18n'
import { taskTree } from '@/states/weekPlanning'
import { Resource, Task } from '@/api'
import { computed, ref, watchEffect } from 'vue'
import {
  draggedObject,
  handleTaskMoveAndResize,
} from '@/pages/weekPlanning/handleTaskMoveAndResize'
import NowBlock from '@/pages/weekPlanning/NowBlock.vue'
import { injectStrict } from '@/injectStrict'
import { ProvidedResources, ResourcesKey } from '@/provided'
import WeekendBlocks from '@/pages/weekPlanning/WeekendBlocks.vue'

const { t } = useI18n()
const props = defineProps<{ headId: Resource['id'] | null }>()
const name = ref<string | false>(false)
const laneElement = ref<HTMLElement>()
const taskMap = computed(() => taskTree.current.value.get(props.headId))
const Resources = injectStrict<ProvidedResources>(ResourcesKey)

const {
  active,
  dragEnter,
  dragLeave,
  dragOver,
  dropTask,
  handleMoveMax,
  handleEndMax,
} = handleTaskMoveAndResize(laneElement)

watchEffect(async () => {
  name.value = props.headId
    ? await Resources.getWorkforceName(props.headId)
    : t('page.weekPlanning.notAssigned')
})

const drop = () => {
  active.value = false
  // get the draggable element
  if (draggedObject.task) {
    const patch: Partial<Task> = {
      startDate: dropTask.value?.startDate,
    }
    if (draggedObject.task.assignedTo !== props.headId) {
      patch.assignedTo = props.headId
    }
    dropTask.value = undefined

    taskTree.patch(draggedObject.task.id, patch)
  }
}
</script>

<style lang="scss" scoped>
@use 'src/style/variables' as v;
@use './weekPlanning' as wp;

.WorkforceLane {
  @include wp.Timeline;
}
</style>
